--[[
--                                           MOUNTY 2009 through 2015 or (c)2009 through 2015
--                                                         by William B. Steele
--                                              [ Draewind <> Silver Hand US <> Alliance ]
--                                                         WOWUI@CompuBall.com
--   
--		This program is free software: you can redistribute it and/or modifyit under the terms of the GNU General Public License as published by
--		the Free Software Foundation, either version 3 of the License, or(at your option) any later version.
		
--		This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
--		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

--		You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>
--]]
--[[
--]]
--------------------------------------------------------------------------------------------------------------------------------
-- Function Library (to smooth transition when the Blizzard API changes)
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_SetStateVariables(State)
	State.IsMounted = false;
	State.IsFlying = false;
	local vehicle = false;
	local taxi = UnitOnTaxi("player");
	if taxi ~= 1 then
		if CanExitVehicle() then
			vehicle = true;
		end
		if IsMounted() or vehicle then
			State.IsMounted = true;
		end
		if IsFlying() then
			State.IsFlying = true;
		end
	end
	return vehicle;
end

function Mounty_CheckMountAura()
	local n, name = 1, "";
	local aura = nil;
	while (UnitAura("player", n)) do
		name = UnitAura("player", n);
		n= n+1;
		if (name == "Telaari Talbuk") then
			aura = name;
		elseif (name == "Frostwolf War Wolf") then
			aura = name;
		elseif (name == "Telaari Siege Engine") then
			aura = name;
		elseif (name == "Wor\'var Demolisher") then
			aura = name;
		end
	end
	return aura;
end
--[[
 1 = 13 (Kalimdor)
 2 = Kalimdor (Eastern Kingdoms)
 3 = 14 (Outland)
 4 = Eastern Kingdoms (Northrend)
 5 = 466 (The Maelstrom)
 6 = Outland (Pandaria)
 7 = 485 (Draenor)
 8 = Northrend
 9 = 751
10 = The Maelstrom
11 = 862
12 = Pandaria
13 = 962
14 = Draenor

	-1 - Cosmic map
    0 - Azeroth
    1 - Kalimdor
    2 - Eastern Kingdoms
    3 - Outland
    4 - Northrend
    5 - The Maelstrom
    6 - Pandaria
    7 - Draenor

--]]
function Mounty_SetMap()
	Mounty_GetMap();
	if not MOUNTY.AddMap then
		MOUNTY.AddMap = {};
		MOUNTY.AddMap[0] = {
			[0] = 0;
		};
	end
	if not MOUNTY.AddMap[0] then
		MOUNTY.AddMap[0] = {
			[0] = 0;
		};
	end
	for c,cc in pairs(MOUNTY.MAP) do
		if not MOUNTY.AddMap[c] then
			MOUNTY.AddMap[c] = {
				[0] = 0;
			};
		end
	end
end

function Mounty_GetMap()
	local problem = false;
	local temp = {GetMapContinents()};
	local continents = temp;
	local zones = {};
	local counter = 0;
	if(MOUNTY_WOWBUILD == "6.0.3") then
		local c, n = 0, 0;
		for z,zz in pairs(temp) do
			c = c + 1;
		end
		counter = c;
		if(c > 7) then
			counter = 0;
			problem = true;
			continents = nil;
			continents = {};
			for t=1,c do
				n = n + 1;
				if (n == 2) then
					counter = counter +1;
					continents[counter] = temp[t];
					n = 0;
				end
			end
		end
	else
		local c, n = 0, 0;
		for z,zz in pairs(temp) do
			c = c + 1;
		end
		counter = c;
		if(c > 7) then
			counter = 0;
			problem = true;
			continents = nil;
			continents = {};
			for t=1,c do
				n = n + 1;
				if (n == 2) then
					counter = counter +1;
					continents[counter] = temp[t];
					n = 0;
				end
			end
		end
	end
	local CONT = counter;
	MOUNTY.MAP[-1] = {};
	MOUNTY.MAP[-1][0] = "Cosmic Map";
	MOUNTY.MAP[0] = {};
	MOUNTY.MAP[0][0] = "Azeroth";
	for cid=1,CONT do
		MOUNTY.MAP[cid] = {};
		MOUNTY.MAP[cid][0] = continents[cid];
		temp = nil;
		zones = nil;
		temp = {GetMapZones(cid)};
		zones = temp;
		z=0;
		for a,aa in pairs(temp) do
			z = z + 1;
		end
		counter = z;
		if problem then
			counter = 0;
			zones = nil;
			zones = {};
			n = 0;
			for t=1,z do
				n = n + 1;
				if (n == 2) then
					counter = counter +1;
					zones[counter] = temp[t];
					n = 0;
				end
			end
		end
		for z,zz in pairs(zones) do
			MOUNTY.MAP[cid][z] = zz;
		end
	end
end

function Mounty_GetMapZone()
	local realZone = GetRealZoneText();
	local MAP = MOUNTY.MAP;
	local ADD = MOUNTY.AddMap;
	local exists = false;
	local contexists = false;

	SetMapToCurrentZone();
	local contNum = GetCurrentMapContinent();
	if(MAP[contNum][0]) then
		continent = MAP[contNum][0];
		contexists = true;
	else
		contexists = false;
		contNum = 0;
		continent = MAP[contNum][0];
	end
	local zoneNum = 0;
	local zone = "Unknown";
	local counter, x = 0,0;
	if contexists then
		for z,zz in pairs(MAP[contNum]) do
			if z > counter then
				counter = z;
			end
			if(realZone == zz) then
				exists = true;
				zoneNum = z;
				zone = realZone;
			end
		end
		if not exists then
			for z=1, ADD[contNum][0] do
				if(realZone == ADD[contNum][z]) then
					exists = true;
					zone = ADD[contNum][z];
					zoneNum = 100 + z;
				end
			end
			if not exists then
				zoneNum = counter + 1;
				MAP[contNum][zoneNum] = realZone;
				zone = MAP[contNum][zoneNum];
				x = ADD[contNum][0] + 1;
				ADD[contNum][x] = zone;
				ADD[contNum][0] = x;
				zoneNum = 100 + x;
			end
		end
	else
		for c,cc in pairs(MAP) do
			for z,zz in pairs(cc) do
				if(realZone == zz) then
					exists = true;
					zoneNum = z;
					zone = realZone;
					contNum = c;
					continent = MAP[c][0];
				end
			end
		end
		if not exists then
					zoneNum = 0;
					zone = "Unknown";
					contNum = -2;
					continent = "Unknown";
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Continent / Index is Unknown.|r");
		end
	end
	MOUNTY.MAP = MAP;
	MOUNTY.AddMap = ADD;

	MOUNTY_CNum = contNum;
	MOUNTY_CONTINENT = continent;
	MOUNTY_CCont = Mounty_ConvertZoneName(MOUNTY_CONTINENT);
	MOUNTY_ZNum = zoneNum;
	MOUNTY_ZONE = zone;

	Mounty_VashjCheck();
	zone = MOUNTY_ZONE;
	return contNum, continent, zoneNum, zone;
end
--[[
function Mounty_GetContinentName()
	SetMapToCurrentZone();
	local contNum = GetCurrentMapContinent();
	local continent = "Unkown";
	if(contNum > 0) then
		continent = MOUNTY.MAP[contNum][0];
	end
	MOUNTY_CCont = Mounty_ConvertZoneName(continent);
	MOUNTY_CONTINENT = continent;
	return continent;
end
--]]
function Mounty_ConvertZoneName(cont)
	if (cont == "Eastern Kingdoms") then
		cont = "Eastern";
	end
	if (cont == "The Maelstrom") then
		cont = "Maelstrom";
	end
	return cont;
end

function Mounty_VashjCheck()
	MOUNTY_SWIMFLAG = Mounty_SwimFlag();
	MOUNTY_VASHJ_FLAG = false;
--	local continent = Mounty_GetContinentName();
--	local contNum, continent, zoneNum, zone = Mounty_GetMapZone();
--	MOUNTY_ZONE = zone;
	if (continent == "Eastern Kingdoms") then
--		MOUNTY_ZONE = MOUNTY.MAP[GetCurrentMapContinent()][GetCurrentMapZone()];
		if (MOUNTY_ZONE == "Abyssal Depths") then
			MOUNTY_ZONE = MOUNTY_VASHJ_TEXT;
		elseif (MOUNTY_ZONE == "Kelp'thar Forest") then
			MOUNTY_ZONE = MOUNTY_VASHJ_TEXT;
		elseif (MOUNTY_ZONE == "Shimmering Expanse") then
			MOUNTY_ZONE = MOUNTY_VASHJ_TEXT;
		elseif (MOUNTY_ZONE == "Vashj'ir") then
			MOUNTY_ZONE = MOUNTY_VASHJ_TEXT;
		end
		if (MOUNTY_VASHJ_TEXT == MOUNTY_ZONE) then
			MOUNTY_VASHJ_FLAG = true;
		else
			MOUNTY_VASHJ_FLAG = false;
		end
	end
end

function Mounty_VashjCheckBAK()
	MOUNTY_VASHJ_FLAG = false;
	MOUNTY_ZONE = MOUNTY.MAP[GetCurrentMapContinent()][GetCurrentMapZone()];
	if (MOUNTY_ZONE == "Abyssal Depths") then
		MOUNTY_ZONE = MOUNTY_VASHJ_TEXT;
	elseif (MOUNTY_ZONE == "Kelp'thar Forest") then
		MOUNTY_ZONE = MOUNTY_VASHJ_TEXT;
	elseif (MOUNTY_ZONE == "Shimmering Expanse") then
		MOUNTY_ZONE = MOUNTY_VASHJ_TEXT;
	elseif (MOUNTY_ZONE == "Vashj'ir") then
		MOUNTY_ZONE = MOUNTY_VASHJ_TEXT;
	end
	if (MOUNTY_VASHJ_TEXT == MOUNTY_ZONE) then
		MOUNTY_VASHJ_FLAG = true;
	end
end

function Mounty_603Continent(zone)
	if(MOUNTY_WOWBUILD == "6.0.3") then
		if (zone == 485) then
			zone = "Draenor";
		end
		if (zone == "Outland") then
			zone = "Pandaria";
		end
		if (zone == 466) then
			zone = "The Maelstrom";
		end
		if (zone == "Eastern") then
			zone = "Northrend";
		end
		if (zone == "Eastern Kingdoms") then
			zone = "Northrend";
		end
		if (zone == 14) then
			zone = "Outland";
		end
		if (zone == "Kalimdor") then
			zone = "Eastern Kingdoms";
		end
		if (zone == 13) then
			zone = "Kalimdor";
		end
	end

	return zone;
end

function Mounty_Stables(Ability)
	local buildID = -1;
	local rank = nil;
	GARRISON_Buildings = nil;
	GARRISON_Buildings = C_Garrison.GetBuildings();
	for i,v in pairs(GARRISON_Buildings) do
		for ii,vv in pairs(v) do
			local s = nil;
			local s = string.find(v.texPrefix, "Stables");
			if(s) then buildID = v.buildingID; end
		end
	end
	if(buildID < 0) then
		Ability.printout.Stables = 0;
	else
		local buildingID, buildingName, texturePrefix, icon, description, rank, currencyID, currencyAmount, goldAmount, timeRequirement, needsPlan, isPreBuilt, possSpecs, upgrades, canUpgrade, isMaxLevel, hasFollowerSlot = C_Garrison.GetBuildingInfo(buildID);
		Ability.printout.Stables = rank;
	end
	if(Ability.printout.Stables == 3) then 
		Ability.Skill.Stables = true;
	end
	return Ability;
end

--------------------------------------------------------------------------------------------------------------------------------
-- C_MountJournal Functions
--------------------------------------------------------------------------------------------------------------------------------

function Mounty_SwimFlag()
	local swimflag = IsSwimming();
	return swimflag;
end

function Mounty_Mount(mountid)
	C_MountJournal.Summon(mountid);
end

function Mounty_Dismount()
	C_MountJournal.Dismiss();
end

function Mounty_GetNumMounts()
	local returnvalue = C_MountJournal.GetNumMounts();
	return returnvalue;
end

function Mounty_GetMountInfo(i)
	local ctn, spellID, icon, issummoned = C_MountJournal.GetMountInfo(i);
	return ID, ctn, spellID, icon, issummoned;
end

function Mounty_SetOwnedList()
	local mounts = {
		["Horde"] = {};
		["Alliance"] = {};
	};
	mounts.Horde[0] = 0;
	mounts.Alliance[0] = 0;
	Mounty_ClearVashMount();
	local special = false;
	local faction = false;
	local alliance = 0;
	local horde = 0;
	local counter = 0;
	local i, ii = 1, Mounty_GetNumMounts();
	if(ii > 0) then
		for i=1,ii do
			if Mounty_MountOwned(i) then
				counter = counter + 1;
				local info = Mounty_GetMountJournalInfo(i);
				if info.mountType == 232 then
					Mounty_SetVashMount(i, info.name);
				end
				if info.mountType == 284 then
					special = true;
				end
				if info.isFactionSpecific then
					if info.faction == "Neutral" then
						info.isFactionSpecific = false;
						alliance = alliance + 1;
						mounts.Alliance[alliance] = info;
						horde = horde + 1;
						mounts.Horde[horde] = info;
					elseif info.faction == "Alliance" then
						alliance = alliance + 1;
						mounts.Alliance[alliance] = info;
					elseif info.faction == "Horde" then
						horde = horde + 1;
						mounts.Horde[horde] = info;
					end
				else
					alliance = alliance + 1;
					mounts.Alliance[alliance] = info;
					horde = horde + 1;
					mounts.Horde[horde] = info;
				end
			end
		end
		mounts[0] = counter;
		mounts.Horde[0] = horde;
		mounts.Alliance[0] = alliance;
	end
	if special then
		Mounty_SpecialMount();
	end
	return mounts;
end

function Mounty_GetMountJournalInfo(mountIndex)
	local temp = {C_MountJournal.GetMountInfo(mountIndex)};
	faction = temp[8];
	if faction then
		if (temp[9] == 1) then
			temp[9] = "Alliance";
		else
			temp[9] = "Horde";
		end
	else
		temp[9] = "Neutral";
	end
	counter = 0;
	for index,value in pairs(temp) do
		counter = counter + 1;
	end
	if not (counter == 11) then
		Mounty_Sound("error");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r|cffff0000 C_MountJournal.GetMountInfo() has "..counter.." items |r");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r|cffff0000 C_MountJournal.GetMountInfo() does not have 11 items on return. |r");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r|cffff0000 EXITING !!!!! |r");
		exit();
	end
	local extra = {C_MountJournal.GetMountInfoExtra(mountIndex)};
	for index,value in pairs(extra) do
		counter = counter + 1;
		temp[counter] = value;
	end
	extra = nil;
	local mount = Mounty_SetMountJournalInfo(mountIndex, temp);
	return mount;
end

function Mounty_SetMountJournalInfo(id, values)
	local source = {"Drop", "Quest", "Vendor", "Profession", "Pet Battle, Achievement", "World Event", "Promotion", "Trading Card Game", "In-Game Shop"};
	local sourceStr = "Unknown";
	local sourceVal = values[6];
	if (sourceVal < 11) and (sourceVal > 0) then sourceStr = source[sourceVal]; end
	local info = {
		ID = id,
		creatureID = values[2],
		displayID = values[12],
		name = values[1],
		iconPath = values[3],
		source = sourceStr,
		isFavorite = values[7],
		isFactionSpecific = values[8],
		faction = values[9],
		descriptionText = values[13],
		sourceText = values[14],
		isSelfMount = values[15],
		mountType = values[16]};
	return info;
end

function Mounty_MountOwned(mountIndex)
	local temp = {C_MountJournal.GetMountInfo(mountIndex)};
	return temp[11];
end

function Mounty_MountSummonable(mountIndex)
	local temp = {C_MountJournal.GetMountInfo(mountIndex)};
	return temp[5];
end

function Mounty_MountActive(mountIndex)
	local temp = {C_MountJournal.GetMountInfo(mountIndex)};
	return temp[4];
end

function Mounty_GetActiveMount()
	local mountID = 0;
	local mountName = "Unknown";
	local i, ii = 1, Mounty_GetNumMounts();
	if(ii > 0) then
		for i=1,ii do
			if Mounty_MountActive(i) then
				mountID = i;
			end
		end
	end
	return mountID;
end

function Mounty_GetTypeMount(faction, mountType)
	local xx, name = Ability.Mount.mounts, MOUNTYNOTSET, 0;
	if(xx > 0) then
		for x = 1,xx do
			if MOUNTY.Owned[faction][x].mountType == mountType then
				name = MOUNTY.Owned[faction][x].name;
			end
		end
	end
	return name;
end

function Mounty_GetSpecialMount(faction)
	local xx, name, id, mountType = Ability.Mount.mounts, MOUNTYNOTSET, 0, 284;
	if(xx > 0) then
		for x = 1,xx do
			if MOUNTY.Owned[faction][x].mountType == mountType then
				name = MOUNTY.Owned[faction][x].name;
				if (name == "Chauffeured Mekgineer's Chopper") or (name == "Chauffeured Mechano-Hog") or (name == "Chauffeured Chopper") then
					id = MOUNTY.Owned[faction][x].ID;
				else
					name = MOUNTYNOTSET;
				end
			end
		end
	end
	return name, id;
end

function Mounty_MountFactionSpec(mountIndex)
	local temp = Mounty_GetMountJournalInfo(mountIndex);
	local spec = temp.isFactionSpecific;
	local faction = temp.faction;
	local name = temp.name;
	return spec, faction, name;
end

function Mounty_PrintMountFaction(mountIndex)
	local temp = Mounty_GetMountJournalInfo(mountIndex);
	local spec = temp.isFactionSpecific;
	local faction = temp.faction;
	local name = temp.name;
	if Mounty_MountOwned(mountIndex) then
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00"..mountIndex.." - "..faction.." - "..name.."|r");
		mount = nil;
	end
end

function Mounty_PrintFactionMount()
	local i, ii = 1, Mounty_GetNumMounts();
	if(ii > 0) then
		for i=1,ii do
			Mounty_PrintMountFaction(i);
		end
	end
end
--------------------------------------------------------------------------------------------------------------------------------
-- C_MountJournal Info and Extra Key
--------------------------------------------------------------------------------------------------------------------------------
--	key = {
--		"name", -- [1] creatureName - Localized name of the mount (string)
--		"creatureID", -- [2] (number) Unique ID of the mount (usable with PlayerModel:SetCreature)
--		"iconPath", -- [3] Path to an icon texture for the mount (string)
--		"isActive", -- [4] true if the mount queried is currently summoned; otherwise false (boolean)
--	    "isSummonable", -- [5] true if the mount can be summoned by this character; otherwise false (boolean)
--		"source", -- [6] A number indicating the source of the mount. (number)
--			        1 - Drop
--			        2 - Quest
--			        3 - Vendor
--			        4 - Profession
--			        5 - Pet Battle
--			        6 - Achievement
--			        7 - World Event
--			        8 - Promotion
--			        9 - Trading Card Game
--			        10 - In-Game Shop
--		"isFavorite", -- [7] (boolean)
--		"isFactionSpecific", -- [8] (boolean)
--		"faction", -- [9] CONVERTED BELOW by this function. (the faction the mount belongs to:
--					0 - Horde
--					1 - Alliance
--					nil - none / both / neutral
--		"unknown", -- [10] (boolean)
--    	"owned", -- [11] (boolean)
------------------------------------------------ EXTRA
--		"displayID", -- [12] [1](number) Unique ID - the display ID of the model for the mount, usable with PlayerModel:SetDisplayInfo()
--		"descriptionText", -- [13] [2] (string) flavor text describing the mount
--		"sourceText", -- [14] [3] (string) information about how the mount is obtained, including vendor name and location, monetary cost, etc.
--		"isSelfMount", -- [15] [4](boolean) true if the player transforms into the mount (eg. Obsidian Nightwing or [Sandstone Drake]), or false for normal mounts
--		"mountType" -- [16] [5] (number) a number indicating the capabilities of the mount; known values include:
--				230 for most ground mounts
--				231 for  [Riding Turtle] and Sea Turtle
--				232 for  [Vashj'ir Seahorse] (was named Abyssal Seahorse prior to Warlords of Draenor)
--				241 for [[Blue Qiraji Battle Tank|Blue, Green, Red, and Yellow Qiraji Battle Tank (restricted to use inside Temple of Ahn'Qiraj)
--				242 for Swift Spectral Gryphon (hidden in the mount journal, used while dead in certain zones)
--				247 for Red Flying Cloud
--				248 for most flying mounts, including those that change capability based on riding skill
--				254 for Subdued Seahorse
--				269 for Azure and Crimson Water Strider
--				284 for Chauffeured Mekgineer's Chopper and Chauffeured Mechano-Hog
--	}
function Mounty_PrintMountInfoList()
	local mounts = {};
	key = {
		"name", -- [1] creatureName - Localized name of the mount (string)
		"creatureID", -- [2] (number) Unique ID of the mount (usable with PlayerModel:SetCreature)
		"iconPath", -- [3] Path to an icon texture for the mount (string)
		"isActive", -- [4] true if the mount queried is currently summoned; otherwise false (boolean)
	    "isSummonable", -- [5] true if the mount can be summoned by this character; otherwise false (boolean)
		"source", -- [6] A number indicating the source of the mount. (number)
--			        1 - Drop
--			        2 - Quest
--			        3 - Vendor
--			        4 - Profession
--			        5 - Pet Battle
--			        6 - Achievement
--			        7 - World Event
--			        8 - Promotion
--			        9 - Trading Card Game
--			        10 - In-Game Shop
		"isFavorite", -- [7] (boolean)
		"isFactionSpecific", -- [8] (boolean)
		"faction", -- [9] CONVERTED BELOW by this function. (the faction the mount belongs to:
--					0 - Horde
--					1 - Alliance
--					nil - none / both / neutral
		"unknown", -- [10] (boolean)
    	"owned", -- [11] (boolean)
------------------------------------------------ EXTRA
		"displayID", -- [12] [1](number) Unique ID - the display ID of the model for the mount, usable with PlayerModel:SetDisplayInfo()
		"descriptionText", -- [13] [2] (string) flavor text describing the mount
		"sourceText", -- [14] [3] (string) information about how the mount is obtained, including vendor name and location, monetary cost, etc.
		"isSelfMount", -- [15] [4](boolean) true if the player transforms into the mount (eg. Obsidian Nightwing or [Sandstone Drake]), or false for normal mounts
		"mountType" -- [16] [5] (number) a number indicating the capabilities of the mount; known values include:
--				230 for most ground mounts
--				231 for  [Riding Turtle] and Sea Turtle
--				232 for  [Vashj'ir Seahorse] (was named Abyssal Seahorse prior to Warlords of Draenor)
--				241 for [[Blue Qiraji Battle Tank|Blue, Green, Red, and Yellow Qiraji Battle Tank (restricted to use inside Temple of Ahn'Qiraj)
--				242 for Swift Spectral Gryphon (hidden in the mount journal, used while dead in certain zones)
--				247 for Red Flying Cloud
--				248 for most flying mounts, including those that change capability based on riding skill
--				254 for Subdued Seahorse
--				269 for Azure and Crimson Water Strider
--				284 for Chauffeured Mekgineer's Chopper and Chauffeured Mechano-Hog
	}
	mounts[0] = 0;
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff---------------------------------------|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r|cffffff00 Mount List: |r");
	local faction = false;
	local mountNum = 0;
	local counter = 0;
	local i, ii = 1, Mounty_GetNumMounts();
	if(ii > 0) then
--ii = 10;
		for i=1,ii do
			local temp = {C_MountJournal.GetMountInfo(i)};
			faction = temp[8];
			if temp[8] then
				if (temp[9] == 1) then
					temp[9] = "Alliance";
				else
					temp[9] = "Horde";
				end
			else
				temp[9] = "Neutral";
			end
			local extra = {C_MountJournal.GetMountInfoExtra(i)};
			counter = 0;
			for index,value in pairs(temp) do
				if value then
					if (index == 4) or (index == 5) then 
						DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 Index = "..index.."   Value =|r|cff00ff00 True |r");
					elseif (index == 7) or (index == 8) then 
						DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 Index = "..index.."   Value =|r|cff00ff00 True |r");
					elseif (index == 10) or (index == 11) then 
						DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 Index = "..mounts[0][index].."   Value =|r|cff00ff00 True |r");
					elseif (index == 15) then 
						DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 Index = "..index.."   Value =|r|cff00ff00 True |r");
					else
						DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 Index = "..index.."   Value = "..value.." |r");
					end
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 Index = "..index.."   Value =|r|cffff0000 False |r");
				end
			end
			for index,value in pairs(temp) do
				counter = counter + 1;
			end
			if not (counter == 11) then
				Mounty_Sound("error");
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r|cffff0000 C_MountJournal.GetMountInfo() has "..counter.." items |r");
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r|cffff0000 C_MountJournal.GetMountInfo() does not have 11 items on return. |r");
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r|cffff0000 EXITING !!!!! |r");
				exit();
			end
			local extra = {C_MountJournal.GetMountInfoExtra(i)};
			for index,value in pairs(extra) do
				counter = counter + 1;
				temp[counter] = value;
			end
			extra = nil;
			if temp[11] then
				mountNum = mountNum +1;
				mounts[mountNum] = Mounty_SetMountInfo(i, temp);
			end
--[[
			for index,value in pairs(temp) do
				if value then
					if (index == 4) or (index == 5) then 
						DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 Index = "..index.."   Value =|r|cff00ff00 True |r");
					elseif (index == 7) or (index == 8) then 
						DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 Index = "..index.."   Value =|r|cff00ff00 True |r");
					elseif (index == 10) or (index == 11) then 
						DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 Index = "..mounts[0][index].."   Value =|r|cff00ff00 True |r");
					elseif (index == 15) then 
						DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 Index = "..index.."   Value =|r|cff00ff00 True |r");
					else
						DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 Index = "..index.."   Value = "..value.." |r");
					end
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 Index = "..index.."   Value =|r|cffff0000 False |r");
				end
			end
--]]
			temp = nil;
		end
	end
	for i=1,mountNum do
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 Mount#"..i.."   mountID = "..mounts[i].mountID.."  Type = "..mounts[i].mountType.."  Name = "..mounts[i].mountName.."|r");
	end
	mounts[0] = mountNum;
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Number of Mounts = "..mounts[0].."|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff---------------------------------------|r");
end


--BELOW OBSOLETE
--------------------------------------------------------------------------------------------------------------------------------
-- Imported and converted/edited from Livestock (c)2008 by Scott Snowman (Recompense on Uldum(US))
-- Many thanks for helping accomplish this task!
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_AddMountList(name, spellID)
	local returnName = name;
	local returnvalue = 1;
	local flying = false;
	local changes = false;
	local depend = false;
	local seahorse = false;
--	GameTooltip_SetDefaultAnchor(MountyToolTip, UIParent)
	MountyToolTip:SetOwner(UIParent, "ANCHOR_NONE")
	MountyToolTip:SetHyperlink("spell:"..spellID) -- pull up the tooltip object we created and set it to the ID of the spell
	for i = 1, MountyToolTip:NumLines() do -- iterate over the number of lines in the tooltip
		local text = _G["MountyToolTipTextLeft"..i]:GetText() -- get the text from each line
		if(i == 1) then
			returnName = text;
		end
		for word in string.gmatch(text, "%S+") do -- look at each word in the line.  NOT %a+ because that apparently doesn't capture unicode characters, for the localized clients.
			if strfind(word, "flying") then
				flying = true
			end	
			if strfind(word, "depend") then
				depend = true
			end	
			if strfind(word, "changes") then
				changes = true
			end	
			if strfind(word, MOUNTY_VASHJ_TEXT) then
				seahorse = true -- seahorse mounts also have the word "Vashj'ir" in them
			end
		end
	end -- parse the tooltip.  The variables outland, northrend, very, fast, location, and changes are set to true if the corresponding text is found
	MountyToolTip:Hide(); -- hide our dummy tooltip
	
	returnvalue = 1;
	if flying then -- Flying Mount 
		returnvalue = 2;
	end
	if depend then -- Riding/Flying Mount
		returnvalue = 3;
	end
	if changes then -- Riding/Flying Mount
		returnvalue = 3;
	end
	if seahorse then -- Vashjir Only Swimming Mount 
		returnvalue = 5;
	end
	return returnvalue, returnName;
end

